
a {
  color: var(--user-value-color);
  text-decoration: underline;
}

a:hover {
  color: var(--current-workspace-main-color);
  text-decoration: underline;
}

::selection {
  background: var(--current-workspace-main-color, #3E87E3);
}

.@{ant-prefix} {

  &-click-animating-node {
    border-color: var(--current-workspace-main-color);
  }

  &-btn {
    transition: none;

    &:hover, &:focus {
      border-color: var(--current-workspace-main-color);
      color: var(--current-workspace-main-color);
    }

    & > i, & > span {
      transition: none;
    }

    &-link {
      color: var(--current-workspace-main-color);

      &:hover {
        color: var(--current-workspace-brightest-color);
      }
    }

    &-primary {
      background-color: var(--current-workspace-main-color);
      border-color: var(--current-workspace-main-color);
      color: white;

      &:hover, &:focus {
        background-color: var(--current-workspace-brightest-color);
        border-color: var(--current-workspace-brightest-color);
        color: white;
      }
    }

    &.no-border-radius {
      border-radius: 0;
    }

    &.no-left-border-radius {
      border-top-left-radius: 0;
      border-bottom-left-radius: 0;
    }
  }

  &-checkbox {

    &-wrapper:hover, &:hover {
      .@{ant-prefix}-checkbox-inner {
        border-color: var(--current-workspace-main-color);
      }
    }

    &-input:focus + .@{ant-prefix}-checkbox-inner {
        border-color: var(--current-workspace-main-color);
    }

    &-checked {
      .@{ant-prefix}-checkbox-inner {
        border-color: var(--current-workspace-main-color);
        background-color: var(--current-workspace-main-color);
      }
    }

    &-checked::after {
      border-color: var(--current-workspace-main-color);
    }

    &-disabled  {
      .@{ant-prefix}-checkbox-inner {
        background-color: #f5f5f5;
      }
    }
  }

  &-radio {
    &:hover &-inner,
    &-wrapper-checked &-checked &-inner {
      transition: none;
      border-color: var(--current-workspace-main-color);
    }

    &-disabled &-input, &-disabled + span, &-disabled &-inner {
      cursor: default;
    }

    &-disabled + span {
      color: var(--label-color);
    }

    &-wrapper:not(&-wrapper-disabled) &-checked &-inner::after {
      transition: none;
      background-color: var(--current-workspace-main-color);
    }

    &-checked::after {
      transition: none;
      border-color: var(--current-workspace-main-color);
    }

    &-button-wrapper-checked:not(&-button-wrapper-disabled)::before {
      opacity: 1;
      background-color: var(--current-workspace-main-color) !important;
      border-color: var(--current-workspace-main-color) !important;
    }

    &-group-solid &-button-wrapper-checked:not(&-button-wrapper-disabled),
    &-group-solid:hover &-button-wrapper-checked:not(&-button-wrapper-disabled) {
      background-color: var(--current-workspace-main-color);
      border-color: var(--current-workspace-main-color) !important;
    }

    &-group:not(&-group-solid) &-button-wrapper-checked:not(&-button-wrapper-disabled),
    &-group:not(&-group-solid):hover &-button-wrapper-checked:not(&-button-wrapper-disabled) {
      border-color: var(--current-workspace-main-color);
      color: var(--current-workspace-main-color);
    }

    &-group &-button-wrapper:hover:not(&-button-wrapper-disabled):not(&-button-wrapper-checked) {
      color: var(--current-workspace-main-color);
    }
  }

  &-dropdown-menu {
    &-item:hover,
    &-submenu-title:hover {
      background-color: var(--background-color);
    }

    &-item, &-submenu-title {
      &-disabled {
        cursor: default;

        &:hover {
          cursor: default;
        }
      }
    }

    &-item:hover > a {
      color: var(--current-workspace-main-color);
    }

    &-item-selected,
    &-submenu-title-selected {
      background-color: white;

      & > a {
        color: var(--current-workspace-main-color);
        background-color: var(--current-workspace-main-color);
      }
    }
  }

  &-select {
    &-arrow {
      color: var(--current-workspace-main-color) !important;
      &-loading {
        font-size: 17px;
        top: 45%;
        margin-right: 5px;
      }
    }

    &-dropdown-menu-item {
      &:active,
      &:hover:not(&-disabled) {
        background-color: var(--background-color);
      }

      &-selected, &-active {
        background-color: var(--background-color) !important;
      }

      &-selected .@{ant-prefix}-select-selected-icon > svg {
        color: var(--user-value-color);
      }
    }

    &-selection {

      &--multiple .@{ant-prefix}-selection__choice {
        color: var(--user-value-color);
      }

      &:hover, &-multiple:hover {
        border-color: var(--current-workspace-main-color);
      }

      &:active, &:focus, &-multiple:active, &-multiple:focus {
        border-color: var(--current-workspace-main-color);
        box-shadow: 0 0 0 2px var(--current-workspace-box-shadow-color);
      }
    }

    &-item-option {
      &:active,
      &:hover:not(&-disabled) {
        background-color: var(--background-color);
      }

      &-selected, &-active {
        background-color: var(--background-color) !important;
      }

      &-selected .@{ant-prefix}-select-selected-icon > svg {
        color: var(--user-value-color);
      }
    }

    &:not(&-disabled):hover &-selector {
      border-color: var(--current-workspace-main-color);
    }

    &-focused&-single:not(&-customize-input) &-selector,
    &-focused&-multiple:not(&-customize-input) &-selector {
      border-color: var(--current-workspace-main-color) !important;
      box-shadow: 0 0 0 2px var(--current-workspace-box-shadow-color) !important;
    }


    &-open &-selection {
      border-color: var(--current-workspace-main-color);
      box-shadow: 0 0 0 2px var(--current-workspace-box-shadow-color);
    }

    &-tree {
      &-node-selected {
        background-color: var(--background-color) !important;
        font-weight: 600;
      }

      &-node-content-wrapper:hover {
        background-color: var(--background-color) !important;
      }
    }
  }

  &-select.sqtm-core-tags > div {
    border-width: 0 !important;
  }

  &-select-selection-placeholder {
    color: var(--label-color);
    opacity: 1;
  }

  &-input {
    &:hover {
      border-color: var(--current-workspace-main-color);
    }

    &:active, &:focus {
      border-color: var(--current-workspace-main-color);
      box-shadow: 0 0 0 2px var(--current-workspace-box-shadow-color);
    }

    &-affix-wrapper:hover & {
      border-color: var(--current-workspace-main-color) !important;
    }

    &-affix-wrapper:hover {
      border-color: var(--current-workspace-main-color) !important;
    }

    &-affix-wrapper-focused {
      border-color: var(--current-workspace-main-color);
      box-shadow: 0 0 0 2px var(--current-workspace-box-shadow-color);
    }

    &.no-right-border-radius {
      border-top-right-radius: 0;
      border-bottom-right-radius: 0;
    }
  }

  &-input-number {
    &:hover {
      border-color: var(--current-workspace-main-color);
    }

    &:active, &:focus {
      border-color: var(--current-workspace-main-color);
      box-shadow: 0 0 0 2px var(--current-workspace-box-shadow-color);
    }

    &-input {
      border-color: var(--current-workspace-main-color) !important;
    }

    &-focused {
      border-color: var(--current-workspace-main-color);
      box-shadow: 0 0 0 2px var(--current-workspace-box-shadow-color) !important;
    }

    &.no-left-border-radius {
      border-top-left-radius: 0;
      border-bottom-left-radius: 0;
    }

    &.no-right-border-radius {
      border-top-right-radius: 0;
      border-bottom-right-radius: 0;
    }
  }

  &-cascader {
    &-picker:focus &-input {
      border-color: var(--current-workspace-main-color);
      box-shadow: 0 0 0 2px var(--current-workspace-box-shadow-color);
    }

    &-picker-open &-input {
      border-color: var(--current-workspace-main-color);
    }

    &-menu-item:hover {
      background-color: var(--current-workspace-brightest-color);
    }
  }

  &-slider {
    &-track,
    &:hover &-track {
      background-color: var(--current-workspace-main-color);
    }

    &-handle,
    &:hover &-handle:not(.@{ant-prefix}-tooltip-open) {
      border-color: var(--current-workspace-main-color);
    }
  }

  &-picker {
    &:hover  {
      border-color: var(--current-workspace-main-color);
    }
    &-focused {
      border-color: var(--current-workspace-main-color);
      box-shadow: 0 0 0 2px var(--current-workspace-brightest-color);
    }

    &-header-view button:hover {
      color: var(--current-workspace-main-color);
    }

    &.no-right-border-radius {
      border-top-right-radius: 0;
      border-bottom-right-radius: 0;
    }

    &-cell {
      &:hover &-inner,
      &-selected &-inner {
        color: var(--current-workspace-contrast-color) !important;
        background-color: var(--current-workspace-main-color) !important;
      }

      &-in-view&-today &-inner {
        color: var(--current-workspace-main-color);

        &:before {
          border-color: var(--current-workspace-main-color) !important;
        }
      }
    }

    &-today-btn {
      color: var(--user-value-color);

      &:hover {
        color: var(--current-workspace-main-color);
      }

    }
  }


  &-calendar {
    &-picker {
      &:hover &-input {
        border-color: var(--current-workspace-main-color) !important;
      }
    }

    &-today &-date {
      color: var(--current-workspace-main-color);
      border-color: var(--current-workspace-main-color);
    }

    &-today&-selected-day &-date,
    &-today:hover &-date {
      color: var(--current-workspace-contrast-color);
    }

    &-cell:hover &-date,
    &-selected-day &-date {
      background-color: var(--current-workspace-main-color);
      color: var(--current-workspace-contrast-color);
    }

    &-in-range-cell::before,
    &-in-range-cell::after {
      background-color: var(--current-workspace-brightest-color) !important;
    }

    &-month-panel {
      &-selected-cell &-month {
        background-color: var(--current-workspace-main-color);
      }

      &-cell:hover &-month {
        color: var(--current-workspace-main-color);
        background-color: var(--current-workspace-brightest-color);
      }
    }

    &-year-panel {
      &-selected-cell &-year {
        background-color: var(--current-workspace-main-color);
      }

      &-cell:hover &-year {
        color: var(--current-workspace-main-color);
        background-color: var(--current-workspace-brightest-color);
      }
    }

    &-decade-panel {
      &-selected-cell &-decade {
        background-color: var(--current-workspace-main-color);
      }

      &-cell:hover &-decade {
        color: var(--current-workspace-main-color);
        background-color: var(--current-workspace-brightest-color);
      }
    }

    &-header {
      a:hover {
        color: var(--current-workspace-main-color) !important;
      }
    }

    & &-ok-btn:not(&-ok-btn-disabled) {
      background-color: var(--current-workspace-main-color);
      border-color: var(--current-workspace-main-color);
    }
  }

  &-menu {
    &.sqtm-custom-submenu {
      border-radius: @border-radius-base !important;
    }

    &-item, &-submenu-title {
      transition: none;
    }

    &-item-disabled, &-submenu-disabled {
      cursor: default;

      > .@{ant-prefix}-menu-submenu-title {
        cursor: default;
      }
    }

    // Fixing a bug on ng-zorro menu when text is translated and too long the arrow is put inside text.
    // It put the arrow more on the right side of the ant-menu but it prevent collapse into title.
    &-submenu {
      &-vertical > &-title > &-arrow {
        width: 0 !important;
      }

      // Prevent the ngzorro main color to apply when sub menu is open
      // &-open also prevent a flash of blue with transition on color attribute
      &-active,
      &-open {
        color: @menu-dark-highlight-color !important;
      }
    }
  }

  &-anchor {
    padding-left: 0;
    font-size: 10px;

    &-wrapper {
      margin-left: 0;
      padding-left: 0;
      background-color: transparent;
    }

    &-ink {
      display: none;
    }

    &-link {
      padding: 8px 2px 8px 2px;
      border-top: 1px solid var(--container-border-color);
      border-bottom: 1px solid var(--container-border-color);

      &-title {
        height: 33px;
        display: flex;
        justify-content: center;
        align-items: center;
      }

      &:hover {
        background-color: #EEEEEF;
        border-top: 1px solid var(--container-border-color);
        border-bottom: 1px solid var(--container-border-color);
      }

      &-active {
        background-color: var(--container-background-color);
        border: 1px solid var(--container-border-color);
        border-top-right-radius: 5px;
        border-bottom-right-radius: 5px;
      }
    }
  }

  &-scroll-number-only {
    transition: none;
  }

  &-collapse {
    background-color: transparent;

    & > &-item > &-header {
      transition: none;
      padding: 0;

      .ant-collapse-arrow svg {
        transition: none;
      }
    }

    &-borderless &-item {
      border: 0;
    }

    &-borderless &-header {
      font-family: "Segoe UI Semibold", "Roboto", serif;
      font-size: 18px;
      font-weight: 500;
    }

    &-borderless > &-item > &-header > &-arrow {
      font-size: 10px;
      top: 32%;
      left: 8px;
    }

    &-borderless &-item &-header {
      padding-left: 26px;
      padding-bottom: 6px;
    }

    &-arrow {
      padding-bottom: 6px;
    }

    &-borderless &-item &-content {
      border: 1px solid var(--container-border-color);
      background-color: var(--container-background-color);
      border-radius: 5px;
      -webkit-border-radius: 5px;
      -moz-border-radius: 5px;

      & .@{ant-prefix}-collapse-content-box {
        padding: 15px;
      }
    }
  }

  &-tag {
    background-color: var(--background-color);
    border-color: var(--container-border-color);
  }

  &-typography-copy:hover,
  &-typography-copy {
    color: var(--current-workspace-main-color);
  }

  &-typography-copy:active,
  &-typography-copy:focus {
    color: var(--current-workspace-brightest-color);
  }

  &-tabs {
    &-nav &-tab-active {
      color: var(--current-workspace-main-color);
    }

    &-tab:hover {
      color: var(--current-workspace-main-color) !important;
    }

    &-ink-bar {
      background-color: var(--current-workspace-main-color) !important;
    }
  }

  &-tooltip {
    max-width: 500px;
  }
}

// this one is tricky, for selected tabs
.@{ant-prefix}-tabs-tab.@{ant-prefix}-tabs-tab-active .@{ant-prefix}-tabs-tab-btn {
  color: var(--current-workspace-main-color) !important;
}
